package main
import (
	"fmt"
	"runtime"
	"sync"
	"time"
	"os"
	"strconv"
)

type foo struct {
	sync.Mutex
	val int
	srcwaitc chan bool
	dstwaitc chan bool
}
var waitc chan bool

func main() {
	start := time.Nanoseconds()
	count, _ := strconv.Atoi(os.Args[1])

	f := &foo{val: -1}
	go sender(f)
	for i := 0; i < count; i++ {
		f.recv()
	}
	t := float64(time.Nanoseconds() - start) / 1e3 / float64(count)
	s := runtime.MemStats
	fmt.Println(count, t, s.Alloc, s.TotalAlloc, s.Sys, s.Lookups, s.Mallocs, s.HeapAlloc, s.HeapSys, s.HeapIdle, s.HeapInuse, s.StackInuse, s.StackSys)
}

func sender(f *foo) {
	for i := 0; ; i++ {
		f.send(i)
	}
}

func (f *foo) recv() (v int) {
	f.Lock()
	defer f.Unlock()

	if f.val == -1 {
		c := make(chan bool, 1)
		f.dstwaitc = c
		f.Unlock()
		<-c
		f.Lock()
	}
	v = f.val
	f.val = -1
	if f.srcwaitc != nil {
		f.srcwaitc <- true
		f.srcwaitc = nil
	}
	return
}

func (f *foo) send(v int) {
	f.Lock()
	defer f.Unlock()

	if f.val != -1 {
		c := make(chan bool, 1)
		f.srcwaitc = c
		f.Unlock()
		<-c
		f.Lock()
	}
	f.val = v
	if f.dstwaitc != nil {
		f.dstwaitc <- true
		f.dstwaitc = nil
	}
}
